<template>
    <v-row>
        <v-col md="12" lg="12">
            <div class="field-label">{{ $t('image') }}</div>
            <v-file-input
                v-model="localValue"
                :placeholder="placeholder"
                :error-messages="errors"
                @click:clear="clearPreview"
                prepend-icon=""
                prepend-inner-icon="mdi-camera"
                accept="image/*"
                :hide-details="hideDetails"
                multiple
                show-size
                outlined
            >
            </v-file-input>
        </v-col>

        <v-col v-if="preview" md="12" lg="12">
            <v-card>
                <v-container fluid fill-height class="image-preview grey lighten-2">
                    <v-row v-if="hasImagePreview" justify="center">
                        <draggable
                            class="d-flex col justify-center flex-wrap"
                            v-model="imagePreview"
                            group="preview"
                            @start="drag = true"
                            @end="onImageSortingEnd"
                        >
                            <v-col
                                v-for="item in imagePreview"
                                :key="item.uuid"
                                class="d-flex child-flex"
                                cols="2"
                            >
                                <v-card flat tile class="d-flex grey lighten-2">
                                    <v-img :src="item.preview" aspect-ratio="1">
                                        <v-btn class="ma-2 primary"
                                               small
                                               icon
                                               left
                                               top
                                               @click="deletePreview(item.uuid)"
                                        >
                                            <v-icon color="white">mdi-close</v-icon>
                                        </v-btn>
                                    </v-img>
                                </v-card>
                            </v-col>
                        </draggable>
                    </v-row>

                    <v-row v-else align="center" justify="center">
                        <v-col cols="4" :class="{ 'mb-4' : isEditMode }">
                            <div class="text-center">
                                <span>
                                    <v-icon x-large color="grey darken-1">mdi-camera</v-icon>
                                </span>
                                <h3 class="grey--text text--darken-1">
                                    {{ $t('preview') }}
                                </h3>
                            </div>
                        </v-col>
                    </v-row>
                </v-container>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import uuid from 'shortid'
    import draggable from 'vuedraggable'

    export default {
        name: "VImageInput",
        components: {
            draggable
        },
        props: {
            value: {
                required: true
            },
            deleted: {
                type: Array,
                default: () => []
            },
            errors: [String, Array],
            preview: {
                type: Boolean,
                default: true
            },
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [String, Boolean],
                default: 'auto'
            }
        },

        computed: {
            localValue: {
                get() {
                    if(this.value.length === 0) return [];

                    return this.value.map(v => { return v.file; });
                },
                set(val) {
                    const models = val.map(v => {
                        return {
                            uuid: uuid.generate(),
                            file: v,
                            sort: 0,
                            preview: this.renderImage(v)
                        }
                    });

                    this.$emit('input', models);
                }
            },

            imagePreview: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            },

            isEditMode() {
                return this.mode === 'edit';
            },

            hasImagePreview() {
                return this.imagePreview.length;
            }
        },

        methods: {
            clearPreview() {
                this.imagePreview = [];
            },

            deletePreview(uuid) {
                const index = this.imagePreview.findIndex(image => image.uuid === uuid);
                this.imagePreview.splice(index, 1);
            },

            onImageSortingEnd() {
                this.imagePreview.forEach((image, index) => {
                    image.sort = index;
                })
            },

            renderImage(file) {
                let reader = new FileReader();

                reader.onload = e => {

                    const index = this.imagePreview.findIndex(i => i.file === file);

                    this.imagePreview[index].preview = e.target.result;
                };

                reader.readAsDataURL(file);
            },
        }
    }
</script>

<style scoped>
    .image-preview {
        min-height: 220px;
    }
</style>
